//
//  MonthCell.swift
//  UkiCalendar
//
//  Created by ukiLab on 2023/10/30.
//

import SwiftUI

struct MonthCell: View {
  private let calendar = Calendar(identifier: .gregorian)
  private let date: Date
  private let tgtMo: Int
  private let month: Int
  private let day: Int
  init(targetMonth: Int, date: Date) {
    self.date = date
    self.tgtMo = targetMonth
    self.month = calendar.component(.month, from: self.date)
    self.day = calendar.component(.day, from: self.date)
  }
  
  var body: some View {
    ZStack(alignment: .top) {
      tgtMo == month ? Constants.bgColorCurrentMonth : Constants.bgColorDifferentMonth
      VStack {
        ZStack {
          Circle()
            .stroke(.gray, lineWidth: 2)
            .frame(width: 20, height: 20)
            .background(
              Circle()
                .foregroundColor(.gray)
            )
          Text("\(self.day)")
            .foregroundStyle(.white)
        }
        .padding(.top, 10)
        EventLabel("event1")
        EventLabel("event2")
        Spacer()
      }
    }
  }
}

#Preview {
  MonthCell(targetMonth: Calendar(identifier: .gregorian).component(.month, from: Date()), date: Date())
}
