//
//  DateExtensionTests.swift
//  UkiCalendarTests
//
//  Created by ukiLab on 2023/10/30.
//

import XCTest
@testable import UkiCalendar

final class DateExtensionTests: XCTestCase {

    override func setUpWithError() throws {
        // Put setup code here. This method is called before the invocation of each test method in the class.
    }

    override func tearDownWithError() throws {
        // Put teardown code here. This method is called after the invocation of each test method in the class.
    }

    func testStartOfMonth1() throws {
      let calendar = Calendar(identifier: .gregorian)
      let date = calendar.date(from: DateComponents(year: 2023, month: 3, day: 1))!
      let expectedDate = calendar.date(from: DateComponents(year: 2023, month: 3, day: 1))!
      let formatter = DateFormatter()
      XCTAssertEqual(formatter.string(from: date.startOfMonth), formatter.string(from: expectedDate))
    }

    func testStartOfMonth2() throws {
      let calendar = Calendar(identifier: .gregorian)
      let date = calendar.date(from: DateComponents(year: 2023, month: 3, day: 5))!
      let expectedDate = calendar.date(from: DateComponents(year: 2023, month: 3, day: 1))!
      let formatter = DateFormatter()
      XCTAssertEqual(formatter.string(from: date.startOfMonth), formatter.string(from: expectedDate))
    }

    func testStartOfMonth3() throws {
      let calendar = Calendar(identifier: .gregorian)
      let date = calendar.date(from: DateComponents(year: 2023, month: 3, day: 31))!
      let expectedDate = calendar.date(from: DateComponents(year: 2023, month: 3, day: 1))!
      let formatter = DateFormatter()
      XCTAssertEqual(formatter.string(from: date.startOfMonth), formatter.string(from: expectedDate))
    }

  func testStartOfNextMonth1() throws {
    let calendar = Calendar(identifier: .gregorian)
    let date = calendar.date(from: DateComponents(year: 2020, month: 2, day: 1))!
    let expectedDate = calendar.date(from: DateComponents(year: 2020, month: 3, day: 1))!
    let formatter = DateFormatter()
    XCTAssertEqual(formatter.string(from: date.startOfNextMonth), formatter.string(from: expectedDate))
  }

  func testEndOfLastMonth1() throws {
    let calendar = Calendar(identifier: .gregorian)
    let date = calendar.date(from: DateComponents(year: 2020, month: 3, day: 1))!
    let expectedDate = calendar.date(from: DateComponents(year: 2020, month: 2, day: 29))!
    let formatter = DateFormatter()
    XCTAssertEqual(formatter.string(from: date.endOfLastMonth), formatter.string(from: expectedDate))
  }

    func testWeekdayOfDay1() throws {
      let calendar = Calendar(identifier: .gregorian)
      let date = calendar.date(from: DateComponents(year: 2023, month: 3, day: 1))!
      XCTAssertEqual(date.weekdayOfDay, 4)
    }

    func testWeekdayOfDay2() throws {
      let calendar = Calendar(identifier: .gregorian)
      let date = calendar.date(from: DateComponents(year: 2023, month: 2, day: 28))!
      XCTAssertEqual(date.weekdayOfDay, 3)
    }

    func testWeekdayOfDay3() throws {
      let calendar = Calendar(identifier: .gregorian)
      let date = calendar.date(from: DateComponents(year: 2020, month: 2, day: 29))!
      XCTAssertEqual(date.weekdayOfDay, 7)
    }

    func testWeekdayOfDay4() throws {
      let calendar = Calendar(identifier: .gregorian)
      let date = calendar.date(from: DateComponents(year: 2020, month: 3, day: 31))!
      XCTAssertEqual(date.endOfLastMonth.weekdayOfDay, 7)
    }

    func testPerformanceExample() throws {
        // This is an example of a performance test case.
        self.measure {
            // Put the code you want to measure the time of here.
        }
    }

}
